<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/PTree/Visitor.hh.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/PTree/Visitor.hh</title>
<link href="../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../Scopes/global.html" >Global Namespace</a></span>
<span class="normal"><a href="../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/PTree/Visitor.hh</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="comment">//</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="comment">// Copyright (C) 2004 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="comment">// All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="comment">// Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="comment">// see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="comment">//</span></span>
<a id="line7"></a><span class="lineno">  7</span><span class="line">#ifndef Synopsis_PTree_Visitor_hh_</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line">#define Synopsis_PTree_Visitor_hh_</span>
<a id="line9"></a><span class="lineno">  9</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line">#include &lt;Synopsis/PTree/NodesFwd.hh&gt;</span>
<a id="line11"></a><span class="lineno"> 11</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis.html" title="namespace Synopsis">Synopsis</a></span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line">{</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="keyword">namespace</span> <a href="../../../Scopes/Synopsis/PTree.html" title="namespace Synopsis::PTree">PTree</a></span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line">{</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line"><span class="comment">//. The Visitor class is used to dynamically resolve</span></span>
<a id="line18"></a><span class="lineno"> 18</span><span class="line"><span class="comment">//. type information about a given Node.</span></span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="comment">//. The default implementation does nothing, so you</span></span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line"><span class="comment">//. only need to implement the methods you actually need.</span></span>
<a id="line21"></a><span class="lineno"> 21</span><span class="line"><span class="comment">//. Any types for which no corresponding 'visit' methods</span></span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line"><span class="comment">//. exist will be caught by the 'visit' of the closest parent. </span></span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line"><span class="keyword">class</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html" title="class Synopsis::PTree::Visitor">Visitor</a></span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">{</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line"><span class="keyword">public</span>:</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">  virtual <a href="../../../Scopes/Synopsis/PTree/Visitor.html#_tVisitor_l_r" title="member function Synopsis::PTree::Visitor::~Visitor()">~Visitor</a>() {}</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lNode_S_r" title="member function Synopsis::PTree::Visitor::visit(Node*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Node.html" title="class Synopsis::PTree::Node">Node</a> *) {}</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lAtom_S_r" title="member function Synopsis::PTree::Visitor::visit(Atom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Atom.html" title="class Synopsis::PTree::Atom">Atom</a> *) {}</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lList_S_r" title="member function Synopsis::PTree::Visitor::visit(List*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/List.html" title="class Synopsis::PTree::List">List</a> *) {}</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">  <span class="comment">// atoms...</span></span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lLiteral_S_r" title="member function Synopsis::PTree::Visitor::visit(Literal*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Literal.html" title="class Synopsis::PTree::Literal">Literal</a> *);</span>
<a id="line32"></a><span class="lineno"> 32</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lCommentedAtom_S_r" title="member function Synopsis::PTree::Visitor::visit(CommentedAtom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CommentedAtom.html" title="class Synopsis::PTree::CommentedAtom">CommentedAtom</a> *);</span>
<a id="line33"></a><span class="lineno"> 33</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDupAtom_S_r" title="member function Synopsis::PTree::Visitor::visit(DupAtom*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DupAtom.html" title="class Synopsis::PTree::DupAtom">DupAtom</a> *);</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lIdentifier_S_r" title="member function Synopsis::PTree::Visitor::visit(Identifier*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Identifier.html" title="class Synopsis::PTree::Identifier">Identifier</a> *);</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lKeyword_S_r" title="member function Synopsis::PTree::Visitor::visit(Keyword*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Keyword.html" title="class Synopsis::PTree::Keyword">Keyword</a> *);</span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Auto*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Auto" title="typedef Synopsis::PTree::Kwd::Auto">Kwd::Auto</a> *);</span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Break*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Break" title="typedef Synopsis::PTree::Kwd::Break">Kwd::Break</a> *);</span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Bool*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Bool" title="typedef Synopsis::PTree::Kwd::Bool">Kwd::Bool</a> *);</span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Case*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Case" title="typedef Synopsis::PTree::Kwd::Case">Kwd::Case</a> *);</span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Catch*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Catch" title="typedef Synopsis::PTree::Kwd::Catch">Kwd::Catch</a> *);</span>
<a id="line41"></a><span class="lineno"> 41</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Char*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Char" title="typedef Synopsis::PTree::Kwd::Char">Kwd::Char</a> *);</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Class*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Class" title="typedef Synopsis::PTree::Kwd::Class">Kwd::Class</a> *);</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Continue*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Continue" title="typedef Synopsis::PTree::Kwd::Continue">Kwd::Continue</a> *);</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Const*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Const" title="typedef Synopsis::PTree::Kwd::Const">Kwd::Const</a> *);</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Default*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Default" title="typedef Synopsis::PTree::Kwd::Default">Kwd::Default</a> *);</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Delete*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Delete" title="typedef Synopsis::PTree::Kwd::Delete">Kwd::Delete</a> *);</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Double*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Double" title="typedef Synopsis::PTree::Kwd::Double">Kwd::Double</a> *);</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Do*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Do" title="typedef Synopsis::PTree::Kwd::Do">Kwd::Do</a> *);</span>
<a id="line49"></a><span class="lineno"> 49</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Else*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Else" title="typedef Synopsis::PTree::Kwd::Else">Kwd::Else</a> *);</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Extern*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Extern" title="typedef Synopsis::PTree::Kwd::Extern">Kwd::Extern</a> *);</span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Float*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Float" title="typedef Synopsis::PTree::Kwd::Float">Kwd::Float</a> *);</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::For*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#For" title="typedef Synopsis::PTree::Kwd::For">Kwd::For</a> *);</span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Friend*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Friend" title="typedef Synopsis::PTree::Kwd::Friend">Kwd::Friend</a> *);</span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Goto*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Goto" title="typedef Synopsis::PTree::Kwd::Goto">Kwd::Goto</a> *);</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Inline*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Inline" title="typedef Synopsis::PTree::Kwd::Inline">Kwd::Inline</a> *);</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::If*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#If" title="typedef Synopsis::PTree::Kwd::If">Kwd::If</a> *);</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Int*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Int" title="typedef Synopsis::PTree::Kwd::Int">Kwd::Int</a> *);</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Long*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Long" title="typedef Synopsis::PTree::Kwd::Long">Kwd::Long</a> *);</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Mutable*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Mutable" title="typedef Synopsis::PTree::Kwd::Mutable">Kwd::Mutable</a> *);</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Namespace*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Namespace" title="typedef Synopsis::PTree::Kwd::Namespace">Kwd::Namespace</a> *);</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::New*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#New" title="typedef Synopsis::PTree::Kwd::New">Kwd::New</a> *);</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Operator*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Operator" title="typedef Synopsis::PTree::Kwd::Operator">Kwd::Operator</a> *);</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Private*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Private" title="typedef Synopsis::PTree::Kwd::Private">Kwd::Private</a> *);</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Protected*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Protected" title="typedef Synopsis::PTree::Kwd::Protected">Kwd::Protected</a> *);</span>
<a id="line65"></a><span class="lineno"> 65</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Public*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Public" title="typedef Synopsis::PTree::Kwd::Public">Kwd::Public</a> *);</span>
<a id="line66"></a><span class="lineno"> 66</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Register*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Register" title="typedef Synopsis::PTree::Kwd::Register">Kwd::Register</a> *);</span>
<a id="line67"></a><span class="lineno"> 67</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Return*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Return" title="typedef Synopsis::PTree::Kwd::Return">Kwd::Return</a> *);</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Short*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Short" title="typedef Synopsis::PTree::Kwd::Short">Kwd::Short</a> *);</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Signed*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Signed" title="typedef Synopsis::PTree::Kwd::Signed">Kwd::Signed</a> *);</span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Static*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Static" title="typedef Synopsis::PTree::Kwd::Static">Kwd::Static</a> *);</span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Struct*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Struct" title="typedef Synopsis::PTree::Kwd::Struct">Kwd::Struct</a> *);</span>
<a id="line72"></a><span class="lineno"> 72</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Switch*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Switch" title="typedef Synopsis::PTree::Kwd::Switch">Kwd::Switch</a> *);</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Template*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Template" title="typedef Synopsis::PTree::Kwd::Template">Kwd::Template</a> *);</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::This*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#This" title="typedef Synopsis::PTree::Kwd::This">Kwd::This</a> *);</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Throw*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Throw" title="typedef Synopsis::PTree::Kwd::Throw">Kwd::Throw</a> *);</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Try*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Try" title="typedef Synopsis::PTree::Kwd::Try">Kwd::Try</a> *);</span>
<a id="line77"></a><span class="lineno"> 77</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Typedef*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Typedef" title="typedef Synopsis::PTree::Kwd::Typedef">Kwd::Typedef</a> *);</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Typename*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Typename" title="typedef Synopsis::PTree::Kwd::Typename">Kwd::Typename</a> *);</span>
<a id="line79"></a><span class="lineno"> 79</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Union*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Union" title="typedef Synopsis::PTree::Kwd::Union">Kwd::Union</a> *);</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Unsigned*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Unsigned" title="typedef Synopsis::PTree::Kwd::Unsigned">Kwd::Unsigned</a> *);</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Using*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Using" title="typedef Synopsis::PTree::Kwd::Using">Kwd::Using</a> *);</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Virtual*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Virtual" title="typedef Synopsis::PTree::Kwd::Virtual">Kwd::Virtual</a> *);</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Void*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Void" title="typedef Synopsis::PTree::Kwd::Void">Kwd::Void</a> *);</span>
<a id="line84"></a><span class="lineno"> 84</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::Volatile*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#Volatile" title="typedef Synopsis::PTree::Kwd::Volatile">Kwd::Volatile</a> *);</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::WChar*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#WChar" title="typedef Synopsis::PTree::Kwd::WChar">Kwd::WChar</a> *);</span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">  virtual <span class="keyword">void</span> <a href="" title="member function Synopsis::PTree::Visitor::visit(Kwd::While*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Kwd.html#While" title="typedef Synopsis::PTree::Kwd::While">Kwd::While</a> *);</span>
<a id="line87"></a><span class="lineno"> 87</span><span class="line">  <span class="comment">//. [ { [ &lt;statement&gt;* ] } ]</span></span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lBrace_S_r" title="member function Synopsis::PTree::Visitor::visit(Brace*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Brace.html" title="class Synopsis::PTree::Brace">Brace</a> *);</span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">  <span class="comment">//. [ { [ &lt;statement&gt;* ] } ]</span></span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lBlock_S_r" title="member function Synopsis::PTree::Visitor::visit(Block*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Block.html" title="class Synopsis::PTree::Block">Block</a> *);</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lClassBody_S_r" title="member function Synopsis::PTree::Visitor::visit(ClassBody*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ClassBody.html" title="class Synopsis::PTree::ClassBody">ClassBody</a> *);</span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTypedef_S_r" title="member function Synopsis::PTree::Visitor::visit(Typedef*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Typedef.html" title="class Synopsis::PTree::Typedef">Typedef</a> *);</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">  <span class="comment">//. [ template &lt; [types] &gt; [decl] ]</span></span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTemplateDecl_S_r" title="member function Synopsis::PTree::Visitor::visit(TemplateDecl*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TemplateDecl.html" title="class Synopsis::PTree::TemplateDecl">TemplateDecl</a> *);</span>
<a id="line95"></a><span class="lineno"> 95</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTemplateInstantiation_S_r" title="member function Synopsis::PTree::Visitor::visit(TemplateInstantiation*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TemplateInstantiation.html" title="class Synopsis::PTree::TemplateInstantiation">TemplateInstantiation</a> *);</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lExternTemplate_S_r" title="member function Synopsis::PTree::Visitor::visit(ExternTemplate*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ExternTemplate.html" title="class Synopsis::PTree::ExternTemplate">ExternTemplate</a> *);</span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lMetaclassDecl_S_r" title="member function Synopsis::PTree::Visitor::visit(MetaclassDecl*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/MetaclassDecl.html" title="class Synopsis::PTree::MetaclassDecl">MetaclassDecl</a> *);</span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">  <span class="comment">//. [ extern [&quot;C++&quot;] [{ body }] ]</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lLinkageSpec_S_r" title="member function Synopsis::PTree::Visitor::visit(LinkageSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/LinkageSpec.html" title="class Synopsis::PTree::LinkageSpec">LinkageSpec</a> *);</span>
<a id="line100"></a><span class="lineno">100</span><span class="line">  <span class="comment">//. [ namespace &lt;identifier&gt; [{ body }] ]</span></span>
<a id="line101"></a><span class="lineno">101</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lNamespaceSpec_S_r" title="member function Synopsis::PTree::Visitor::visit(NamespaceSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/NamespaceSpec.html" title="class Synopsis::PTree::NamespaceSpec">NamespaceSpec</a> *);</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">  <span class="comment">//. [ using namespace Foo ; ]</span></span>
<a id="line103"></a><span class="lineno">103</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lUsingDirective_S_r" title="member function Synopsis::PTree::Visitor::visit(UsingDirective*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/UsingDirective.html" title="class Synopsis::PTree::UsingDirective">UsingDirective</a> *);</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">  <span class="comment">//. One of:</span></span>
<a id="line105"></a><span class="lineno">105</span><span class="line"><span class="comment">  //.</span></span>
<a id="line106"></a><span class="lineno">106</span><span class="line"><span class="comment">  //. - Variables: [ [modifiers] name [declarators] ; ]</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line"><span class="comment">  //. - Function: prototype: [ [modifiers] name [declarators] ; ]</span></span>
<a id="line108"></a><span class="lineno">108</span><span class="line"><span class="comment">  //. - Typedef: ?</span></span>
<a id="line109"></a><span class="lineno">109</span><span class="line"><span class="comment">  //. - Class definition: [ [modifiers] [class foo ...] [declarators]? ; ]</span></span>
<a id="line110"></a><span class="lineno">110</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDeclaration_S_r" title="member function Synopsis::PTree::Visitor::visit(Declaration*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Declaration.html" title="class Synopsis::PTree::Declaration">Declaration</a> *);</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">  <span class="comment">//. [ namespace Foo = Bar ; ]</span></span>
<a id="line112"></a><span class="lineno">112</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lNamespaceAlias_S_r" title="member function Synopsis::PTree::Visitor::visit(NamespaceAlias*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/NamespaceAlias.html" title="class Synopsis::PTree::NamespaceAlias">NamespaceAlias</a> *);</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">  <span class="comment">//. Function definition: [ [modifiers] name declarator [ { ... } ] ]</span></span>
<a id="line114"></a><span class="lineno">114</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lFunctionDefinition_S_r" title="member function Synopsis::PTree::Visitor::visit(FunctionDefinition*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FunctionDefinition.html" title="class Synopsis::PTree::FunctionDefinition">FunctionDefinition</a> *);</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">  <span class="comment">//. One of:</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line"><span class="comment">  //.</span></span>
<a id="line117"></a><span class="lineno">117</span><span class="line"><span class="comment">  //. - [ decl-specifier-seq ]</span></span>
<a id="line118"></a><span class="lineno">118</span><span class="line"><span class="comment">  //. - [ decl-specifier-seq declarator ]</span></span>
<a id="line119"></a><span class="lineno">119</span><span class="line"><span class="comment">  //. - [ decl-specifier-seq declarator = assignment-expression ]</span></span>
<a id="line120"></a><span class="lineno">120</span><span class="line"><span class="comment">  //. - [ decl-specifier-seq abstract-declarator ]</span></span>
<a id="line121"></a><span class="lineno">121</span><span class="line"><span class="comment">  //. - [ decl-specifier-seq abstract-declarator = assignment-expression ]</span></span>
<a id="line122"></a><span class="lineno">122</span><span class="line"><span class="comment">  //. - [ decl-specifier-seq = assignment-expression ]</span></span>
<a id="line123"></a><span class="lineno">123</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lParameterDeclaration_S_r" title="member function Synopsis::PTree::Visitor::visit(ParameterDeclaration*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ParameterDeclaration.html" title="class Synopsis::PTree::ParameterDeclaration">ParameterDeclaration</a> *);</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">  <span class="comment">//. [ using Foo `::` x ; ]</span></span>
<a id="line125"></a><span class="lineno">125</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lUsingDeclaration_S_r" title="member function Synopsis::PTree::Visitor::visit(UsingDeclaration*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/UsingDeclaration.html" title="class Synopsis::PTree::UsingDeclaration">UsingDeclaration</a> *);</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">  <span class="comment">//. [ [ declarator { = &lt;expr&gt; } ] , ... ]</span></span>
<a id="line127"></a><span class="lineno">127</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDeclarator_S_r" title="member function Synopsis::PTree::Visitor::visit(Declarator*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Declarator.html" title="class Synopsis::PTree::Declarator">Declarator</a> *);</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lName_S_r" title="member function Synopsis::PTree::Visitor::visit(Name*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Name.html" title="class Synopsis::PTree::Name">Name</a> *);</span>
<a id="line129"></a><span class="lineno">129</span><span class="line">  <span class="comment">//. [ [type] ( [expr] ) ]</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lFstyleCastExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(FstyleCastExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FstyleCastExpr.html" title="class Synopsis::PTree::FstyleCastExpr">FstyleCastExpr</a> *);</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lClassSpec_S_r" title="member function Synopsis::PTree::Visitor::visit(ClassSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ClassSpec.html" title="class Synopsis::PTree::ClassSpec">ClassSpec</a> *);</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">  <span class="comment">//. [ enum [name] [{ [name [= value] ]* }] ]</span></span>
<a id="line133"></a><span class="lineno">133</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lEnumSpec_S_r" title="member function Synopsis::PTree::Visitor::visit(EnumSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/EnumSpec.html" title="class Synopsis::PTree::EnumSpec">EnumSpec</a> *);</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">  <span class="comment">//. One of:</span></span>
<a id="line135"></a><span class="lineno">135</span><span class="line"><span class="comment">  //.</span></span>
<a id="line136"></a><span class="lineno">136</span><span class="line"><span class="comment">  //. - [typename]</span></span>
<a id="line137"></a><span class="lineno">137</span><span class="line"><span class="comment">  //. - [typename identifier]</span></span>
<a id="line138"></a><span class="lineno">138</span><span class="line"><span class="comment">  //. - [typename identifier = type-id]</span></span>
<a id="line139"></a><span class="lineno">139</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTypeParameter_S_r" title="member function Synopsis::PTree::Visitor::visit(TypeParameter*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TypeParameter.html" title="class Synopsis::PTree::TypeParameter">TypeParameter</a> *);</span>
<a id="line140"></a><span class="lineno">140</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lAccessSpec_S_r" title="member function Synopsis::PTree::Visitor::visit(AccessSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/AccessSpec.html" title="class Synopsis::PTree::AccessSpec">AccessSpec</a> *);</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lAccessDecl_S_r" title="member function Synopsis::PTree::Visitor::visit(AccessDecl*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/AccessDecl.html" title="class Synopsis::PTree::AccessDecl">AccessDecl</a> *);</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lUserAccessSpec_S_r" title="member function Synopsis::PTree::Visitor::visit(UserAccessSpec*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/UserAccessSpec.html" title="class Synopsis::PTree::UserAccessSpec">UserAccessSpec</a> *);</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">  <span class="comment">//. [ if ( expr ) statement (else statement)? ]</span></span>
<a id="line144"></a><span class="lineno">144</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lIfStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(IfStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/IfStatement.html" title="class Synopsis::PTree::IfStatement">IfStatement</a> *);</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">  <span class="comment">//. [ switch ( expr ) statement ]</span></span>
<a id="line146"></a><span class="lineno">146</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lSwitchStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(SwitchStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/SwitchStatement.html" title="class Synopsis::PTree::SwitchStatement">SwitchStatement</a> *);</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">  <span class="comment">//. [ while ( expr ) statement ]</span></span>
<a id="line148"></a><span class="lineno">148</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lWhileStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(WhileStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/WhileStatement.html" title="class Synopsis::PTree::WhileStatement">WhileStatement</a> *);</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">  <span class="comment">//. [ do [{ ... }] while ( [...] ) ; ]</span></span>
<a id="line150"></a><span class="lineno">150</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDoStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(DoStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DoStatement.html" title="class Synopsis::PTree::DoStatement">DoStatement</a> *);</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">  <span class="comment">//. [ for ( stmt expr ; expr ) statement ]</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lForStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(ForStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ForStatement.html" title="class Synopsis::PTree::ForStatement">ForStatement</a> *);</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">  <span class="comment">//. [ try [{}] [catch ( arg ) [{}] ]* ]</span></span>
<a id="line154"></a><span class="lineno">154</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTryStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(TryStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TryStatement.html" title="class Synopsis::PTree::TryStatement">TryStatement</a> *);</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">  <span class="comment">//. [ break ; ]</span></span>
<a id="line156"></a><span class="lineno">156</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lBreakStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(BreakStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/BreakStatement.html" title="class Synopsis::PTree::BreakStatement">BreakStatement</a> *);</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lContinueStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(ContinueStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ContinueStatement.html" title="class Synopsis::PTree::ContinueStatement">ContinueStatement</a> *);</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lReturnStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(ReturnStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ReturnStatement.html" title="class Synopsis::PTree::ReturnStatement">ReturnStatement</a> *);</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lGotoStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(GotoStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/GotoStatement.html" title="class Synopsis::PTree::GotoStatement">GotoStatement</a> *);</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">  <span class="comment">//. [ case expr : [expr] ]</span></span>
<a id="line161"></a><span class="lineno">161</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lCaseStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(CaseStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CaseStatement.html" title="class Synopsis::PTree::CaseStatement">CaseStatement</a> *);</span>
<a id="line162"></a><span class="lineno">162</span><span class="line">  <span class="comment">//. [ default : [expr] ]</span></span>
<a id="line163"></a><span class="lineno">163</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDefaultStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(DefaultStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DefaultStatement.html" title="class Synopsis::PTree::DefaultStatement">DefaultStatement</a> *);</span>
<a id="line164"></a><span class="lineno">164</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lLabelStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(LabelStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/LabelStatement.html" title="class Synopsis::PTree::LabelStatement">LabelStatement</a> *);</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lExprStatement_S_r" title="member function Synopsis::PTree::Visitor::visit(ExprStatement*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ExprStatement.html" title="class Synopsis::PTree::ExprStatement">ExprStatement</a> *);</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">  <span class="comment">//. [ expr (, expr)* ]</span></span>
<a id="line167"></a><span class="lineno">167</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lExpression_S_r" title="member function Synopsis::PTree::Visitor::visit(Expression*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/Expression.html" title="class Synopsis::PTree::Expression">Expression</a> *);</span>
<a id="line168"></a><span class="lineno">168</span><span class="line">  <span class="comment">//. [left = right]</span></span>
<a id="line169"></a><span class="lineno">169</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lAssignExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(AssignExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/AssignExpr.html" title="class Synopsis::PTree::AssignExpr">AssignExpr</a> *);</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lCondExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(CondExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CondExpr.html" title="class Synopsis::PTree::CondExpr">CondExpr</a> *);</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">  <span class="comment">//. [left op right]</span></span>
<a id="line172"></a><span class="lineno">172</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lInfixExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(InfixExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/InfixExpr.html" title="class Synopsis::PTree::InfixExpr">InfixExpr</a> *);</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lPmExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(PmExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/PmExpr.html" title="class Synopsis::PTree::PmExpr">PmExpr</a> *);</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">  <span class="comment">//. ( type-expr ) expr   ..type-expr is type encoded</span></span>
<a id="line175"></a><span class="lineno">175</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lCastExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(CastExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/CastExpr.html" title="class Synopsis::PTree::CastExpr">CastExpr</a> *);</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">  <span class="comment">//. [op expr]</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lUnaryExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(UnaryExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/UnaryExpr.html" title="class Synopsis::PTree::UnaryExpr">UnaryExpr</a> *);</span>
<a id="line178"></a><span class="lineno">178</span><span class="line">  <span class="comment">//. [ throw [expr] ]</span></span>
<a id="line179"></a><span class="lineno">179</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lThrowExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(ThrowExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ThrowExpr.html" title="class Synopsis::PTree::ThrowExpr">ThrowExpr</a> *);</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">  <span class="comment">//. [ sizeof ( [type [???] ] ) ]</span></span>
<a id="line181"></a><span class="lineno">181</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lSizeofExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(SizeofExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/SizeofExpr.html" title="class Synopsis::PTree::SizeofExpr">SizeofExpr</a> *);</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lOffsetofExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(OffsetofExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/OffsetofExpr.html" title="class Synopsis::PTree::OffsetofExpr">OffsetofExpr</a> *);</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTypeidExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(TypeidExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TypeidExpr.html" title="class Synopsis::PTree::TypeidExpr">TypeidExpr</a> *);</span>
<a id="line184"></a><span class="lineno">184</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lTypeofExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(TypeofExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/TypeofExpr.html" title="class Synopsis::PTree::TypeofExpr">TypeofExpr</a> *);</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lNewExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(NewExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/NewExpr.html" title="class Synopsis::PTree::NewExpr">NewExpr</a> *);</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">  <span class="comment">//. [ delete [expr] ]</span></span>
<a id="line187"></a><span class="lineno">187</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDeleteExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(DeleteExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DeleteExpr.html" title="class Synopsis::PTree::DeleteExpr">DeleteExpr</a> *);</span>
<a id="line188"></a><span class="lineno">188</span><span class="line">  <span class="comment">//. &lt;postfix&gt; \[ &lt;expr&gt; \]</span></span>
<a id="line189"></a><span class="lineno">189</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lArrayExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(ArrayExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ArrayExpr.html" title="class Synopsis::PTree::ArrayExpr">ArrayExpr</a> *);</span>
<a id="line190"></a><span class="lineno">190</span><span class="line">  <span class="comment">//. [ postfix ( args ) ]</span></span>
<a id="line191"></a><span class="lineno">191</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lFuncallExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(FuncallExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/FuncallExpr.html" title="class Synopsis::PTree::FuncallExpr">FuncallExpr</a> *);</span>
<a id="line192"></a><span class="lineno">192</span><span class="line">  <span class="comment">//. [ expr ++ ]</span></span>
<a id="line193"></a><span class="lineno">193</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lPostfixExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(PostfixExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/PostfixExpr.html" title="class Synopsis::PTree::PostfixExpr">PostfixExpr</a> *);</span>
<a id="line194"></a><span class="lineno">194</span><span class="line">  <span class="comment">//. [ postfix . name ]</span></span>
<a id="line195"></a><span class="lineno">195</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lDotMemberExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(DotMemberExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/DotMemberExpr.html" title="class Synopsis::PTree::DotMemberExpr">DotMemberExpr</a> *);</span>
<a id="line196"></a><span class="lineno">196</span><span class="line">  <span class="comment">//. [ postfix -&gt; name ]</span></span>
<a id="line197"></a><span class="lineno">197</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lArrowMemberExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(ArrowMemberExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ArrowMemberExpr.html" title="class Synopsis::PTree::ArrowMemberExpr">ArrowMemberExpr</a> *);</span>
<a id="line198"></a><span class="lineno">198</span><span class="line">  <span class="comment">//. [ ( expr ) ]</span></span>
<a id="line199"></a><span class="lineno">199</span><span class="line">  virtual <span class="keyword">void</span> <a href="../../../Scopes/Synopsis/PTree/Visitor.html#visit_lParenExpr_S_r" title="member function Synopsis::PTree::Visitor::visit(ParenExpr*)">visit</a>(<a href="../../../Scopes/Synopsis/PTree/ParenExpr.html" title="class Synopsis::PTree::ParenExpr">ParenExpr</a> *);</span>
<a id="line200"></a><span class="lineno">200</span><span class="line">};</span>
<a id="line201"></a><span class="lineno">201</span>
<a id="line202"></a><span class="lineno">202</span><span class="line">}</span>
<a id="line203"></a><span class="lineno">203</span><span class="line">}</span>
<a id="line204"></a><span class="lineno">204</span>
<a id="line205"></a><span class="lineno">205</span><span class="line">#endif</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:28:03 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
